+		-@echo ""
 
 $(LIBDIR)libdsap.a:     libdsap.a
 		@for i in libdsap.* ;\
diff -u --recursive --new-file isode-8.0/dsap/common/Makefile isode-8.0-linux/dsap/common/Makefile
--- isode-8.0/dsap/common/Makefile	Tue Jun 16 13:12:40 1992
+++ isode-8.0-linux/dsap/common/Makefile	Tue Aug 24 12:10:09 1993
@@ -128,6 +128,18 @@
 		$(LINT) $(LFLAGS) $(CFILES) $(LLIBS) \
 			| grep -v "warning: possible pointer alignment problem"
 
+zap-common:
+		-rm -f $(OFILES) libcommon.a commonvrsn.o
+
+linux-lib:	zap-common ../../jump/libcommon.a
+
+../../jump/libcommon.a:	libcommon.a
+		-rm -f $@
+		cp libcommon.a $@
+		@$(UTILDIR)make-lib.sh $(SYSTEM) $@ -ranlib
+		-@ls -gls $@
+		-@echo ""
+
 test:		test.o libcommon.a ../libx500as.a
 		$(LDCC) $(LDFLAGS) test.o libcommon.a ../libx500as.a \
 			libcommon.a $(LIBISODE) -o test
diff -u --recursive --new-file isode-8.0/dsap/common/integer.c isode-8.0-linux/dsap/common/integer.c
--- isode-8.0/dsap/common/integer.c	Tue Jun 16 13:13:16 1992
+++ isode-8.0-linux/dsap/common/integer.c	Wed Jan  5 11:15:44 1994
@@ -108,7 +108,9 @@
 static int * intparse (str)
 char * str;
 {
+#ifndef atoi
 int atoi();
+#endif
 int * x;
 
 	x = (int *) smalloc (sizeof (int));
diff -u --recursive --new-file isode-8.0/dsap/net/Makefile isode-8.0-linux/dsap/net/Makefile
--- isode-8.0/dsap/net/Makefile	Tue Jun 16 13:14:06 1992
+++ isode-8.0-linux/dsap/net/Makefile	Tue Aug 24 12:11:13 1993
@@ -88,6 +88,18 @@
 netvrsn.c:      $(OFILES)
 		@$(UTILDIR)version.sh net > $@
 
+zap-net:
+		-rm -f $(OFILES) libnet.a netvrsn.o
+
+linux-lib:	zap-net ../../jump/libnet.a
+
+../../jump/libnet.a:	libnet.a
+		-rm -f $@
+		cp libnet.a $@
+		@$(UTILDIR)make-lib.sh $(SYSTEM) $@ -ranlib
+		-@ls -gls $@
+		-@echo ""
+
 l-libnet:       $(CFILES) true
 		$(LINT) $(LFLAGS) $(CFILES) $(LLIBS) \
 			| grep -v "warning: possible pointer alignment problem"
diff -u --recursive --new-file isode-8.0/dsap/x500as/Makefile isode-8.0-linux/dsap/x500as/Makefile
--- isode-8.0/dsap/x500as/Makefile	Tue Jun 16 13:14:33 1992
+++ isode-8.0-linux/dsap/x500as/Makefile	Tue Aug 24 12:08:21 1993
@@ -81,6 +81,18 @@
 l-libx500as:;	$(LINT) $(LFLAGS) $(CFILES) $(PEPY-C) $(LLIBS) \
 			| grep -v "warning: possible pointer alignment problem"
 
+zap-x500as:
+		-rm -f $(OFILES) libx500as.a x500asvrsn.o
+
+linux-lib:	zap-x500as ../../jump/libx500as.a
+
+../../jump/libx500as.a:	libx500as.a
+		-rm -f $@
+		cp libx500as.a $@
+		@$(UTILDIR)make-lib.sh $(SYSTEM) $@ -ranlib
+		-@ls -gls $@
+		-@echo ""
+
 
 #######################################################
 # saber
diff -u --recursive --new-file isode-8.0/ftam/Makefile isode-8.0-linux/ftam/Makefile
--- isode-8.0/ftam/Makefile	Tue Jun 16 13:14:56 1992
+++ isode-8.0-linux/ftam/Makefile	Wed Aug 25 14:33:01 1993
@@ -78,6 +78,19 @@
 
 inst-libftam:	$(LIBDIR)libftam.a inst-headers $(LINTDIR)llib-lftam
 
+zap-ftam:
+		-rm -f $(OFILES) libftam.a \
+			CONT_tables.o FADU_tables.o FTAM_tables.o ftamvrsn.o
+
+linux-lib:	zap-ftam ../jump/libftam.a
+
+../jump/libftam.a:	libftam
+		-rm -f $@
+		cp libftam.a $@
+		@$(UTILDIR)make-lib.sh $(SYSTEM) $@ -ranlib
+		-@ls -gls $@
+		-@echo ""
+
 $(LIBDIR)libftam.a:	libftam.a
 		-rm -f $@
 		cp libftam.a $@
diff -u --recursive --new-file isode-8.0/ftam2/ftamd-select.c isode-8.0-linux/ftam2/ftamd-select.c
--- isode-8.0/ftam2/ftamd-select.c	Tue Jun 16 13:15:49 1992
+++ isode-8.0-linux/ftam2/ftamd-select.c	Wed Jan  5 11:15:49 1994
@@ -28,6 +28,9 @@
 #include <grp.h>
 #include <stdio.h>
 #include <pwd.h>
+#ifdef _POSIX_SOURCE
+#include <unistd.h>
+#endif
 #include "ftamsystem.h"
 
 
@@ -63,6 +66,10 @@
 #endif
 
 
+#if !defined(SYS5) && !defined(BRIDGE)
+static int  EACCESS ();
+#endif
+
 #ifdef	SYS5
 #define	EACCESS	access
 
@@ -1528,13 +1535,21 @@
 {
     int	    result;
 
+#ifdef _POSIX_SOURCE
+    (void) setreuid (myuid, 0);
+#else
     (void) seteuid (0);
     (void) setruid (myuid);
+#endif
 
     result = access (file, mode);
 
+#ifdef _POSIX_SOURCE
+    (void) setreuid (0, myuid);
+#else
     (void) setruid (0);
     (void) seteuid (myuid);
+#endif
 
     return result;
 }
diff -u --recursive --new-file isode-8.0/ftam2/ftamd-trans.c isode-8.0-linux/ftam2/ftamd-trans.c
--- isode-8.0/ftam2/ftamd-trans.c	Tue Jun 16 13:15:50 1992
+++ isode-8.0-linux/ftam2/ftamd-trans.c	Wed Jan  5 11:15:49 1994
@@ -31,6 +31,10 @@
 #include <sys/times.h>
 #define	TMS
 #endif
+#ifdef _POSIX_SOURCE
+#include <sys/times.h>
+#define TMS
+#endif
 
 /*    DATA */
 
diff -u --recursive --new-file isode-8.0/ftam2/ftamsystem.c isode-8.0-linux/ftam2/ftamsystem.c
--- isode-8.0/ftam2/ftamsystem.c	Tue Jun 16 13:15:52 1992
+++ isode-8.0-linux/ftam2/ftamsystem.c	Wed Jan  5 11:15:49 1994
@@ -44,6 +44,7 @@
 
 #ifdef SHADOW_PW
 #include <shadow.h>
+#include <shadow/pwauth.h>
 #endif
 
 #ifdef	SYS5
@@ -345,14 +346,23 @@
       else
           pw->pw_passwd = shad_res->sp_pwdp;
     }
-#endif /* SHADOW_PW */
-
 
+    if (!guest) {
+          if (pw->pw_passwd && pw->pw_passwd[0] == '@'
+          && pw_auth(pw->pw_passwd, pw->pw_name, PW_FTP, fts->fts_password)) {
+               seterr (FS_ACS_PASSWORD, EREF_RFSU, EREF_IFSU, "");
+          } else if (!valid(fts->fts_password, pw)) {
+               seterr (FS_ACS_PASSWORD, EREF_RFSU, EREF_IFSU, "");
+          }
+    }
+#else /* SHADOW_PW */
     if ((!guest && fts -> fts_password == NULL)
 	    || *pw -> pw_passwd == NULL
 	    || (!guest && !chkpassword (initiator, pw -> pw_passwd,
 					fts -> fts_password)))
 	seterr (FS_ACS_PASSWORD, EREF_RFSU, EREF_IFSU, "");
+#endif /* SHADOW_PW */
+
 
 #ifdef DEBUG
     advise (LLOG_DEBUG, NULLCP,
diff -u --recursive --new-file isode-8.0/ftam2/ftamuser.c isode-8.0-linux/ftam2/ftamuser.c
--- isode-8.0/ftam2/ftamuser.c	Tue Jun 16 13:15:53 1992
+++ isode-8.0-linux/ftam2/ftamuser.c	Wed Jan  5 11:15:49 1994
@@ -34,6 +34,10 @@
 #include <sys/times.h>
 #define	TMS
 #endif
+#ifdef _POSIX_SOURCE
+#include <sys/times.h>
+#define TMS
+#endif
 #ifdef	BSD42
 #include <sys/ioctl.h>
 #endif
diff -u --recursive --new-file isode-8.0/h/general.h isode-8.0-linux/h/general.h
--- isode-8.0/h/general.h	Wed Jun 17 11:32:31 1992
+++ isode-8.0-linux/h/general.h	Thu Aug 19 10:08:42 1993
@@ -270,6 +270,7 @@
 
 /*  ntohs etc */
 
+#ifndef __linux__
 #ifndef	ntohs
 unsigned short	ntohs ();
 #endif
@@ -282,6 +283,7 @@
 #ifndef	htonl
 unsigned long	htonl ();
 #endif
+#endif /* __linux__ */
 
 int	char2bcd ();
 int	bcd2char ();
diff -u --recursive --new-file isode-8.0/h/manifest.h isode-8.0-linux/h/manifest.h
--- isode-8.0/h/manifest.h	Wed Jun 17 11:32:31 1992
+++ isode-8.0-linux/h/manifest.h	Fri Sep 10 15:57:52 1993
@@ -200,7 +200,7 @@
 #include <sys/select.h>
 #endif
 
-#ifdef	SYS5NLY
+#ifdef SYS5NLY
 typedef unsigned char	u_char;
 typedef unsigned short	u_short;
 typedef unsigned int	u_int;
@@ -303,7 +303,7 @@
 /*    POSIX */
 
 #ifndef	SETSID
-#if	defined(SUNOS41) || defined(BSD44) || defined (SVR4) || defined(_AIX)
+#if	defined(SUNOS41) || defined(BSD44) || defined (SVR4) || defined(_AIX) | defined(__linux__)
 #define	SETSID
 #endif
 #endif
diff -u --recursive --new-file isode-8.0/h/psap.h isode-8.0-linux/h/psap.h
--- isode-8.0/h/psap.h	Wed Jun 17 11:32:31 1992
+++ isode-8.0-linux/h/psap.h	Thu Sep  2 16:17:48 1993
@@ -541,9 +541,13 @@
 extern struct qbuf *Fqb;
 extern struct qbuf *Qb;
 
+#ifdef USE_QBUF2PE_FAST
+	/*  This is a faster version of qbuf2pe, but it has a memory leak. */
 #define qbuf2pe(qb, len, result) (Byteno = 0, Hqb = qb, \
                                         Fqb = (Qb = (qb) -> qb_forw), \
                                         qbuf2pe_f (result))
+#endif
+
 PE	qbuf2pe_f ();
 char   *qb2str ();
 struct qbuf *str2qb ();
diff -u --recursive --new-file isode-8.0/h/quipu/oid.h isode-8.0-linux/h/quipu/oid.h
--- isode-8.0/h/quipu/oid.h	Wed Jun 17 11:32:32 1992
+++ isode-8.0-linux/h/quipu/oid.h	Thu Sep  2 16:17:46 1993
@@ -79,6 +79,7 @@
 
 	/* NON leaf object class */
 #define QUIPU_DSA	"0.9.2342.19200300.99.3.1"
+#define QUIPUOBJECT	"0.9.2342.19200300.99.3.2"
 #define NONLEAFOBJECT	"0.9.2342.19200300.99.3.6"
 #define EXTERNOBJECT	"0.9.2342.19200300.99.3.9"
 
diff -u --recursive --new-file isode-8.0/h/sys.file.h isode-8.0-linux/h/sys.file.h
--- isode-8.0/h/sys.file.h	Wed Jun 17 11:32:31 1992
+++ isode-8.0-linux/h/sys.file.h	Thu Sep 16 10:36:05 1993
@@ -31,7 +31,7 @@
 #include <sys/ioctl.h>
 #endif
 
-#ifdef  BSD42
+#if defined(BSD42) || defined(__linux__)
 #include <sys/file.h>
 #else    
 #ifdef  SYS5
diff -u --recursive --new-file isode-8.0/h/usr.dirent.h isode-8.0-linux/h/usr.dirent.h
--- isode-8.0/h/usr.dirent.h	Wed Jun 17 11:32:31 1992
+++ isode-8.0-linux/h/usr.dirent.h	Fri Dec  3 13:27:48 1993
@@ -56,8 +56,9 @@
 
 extern char             *getcwd ();
 
-
+#ifndef __linux__
 #define	scandir	_scandir
 #define	alphasort _alphasort
+#endif
 
 extern char *direntversion;
diff -u --recursive --new-file isode-8.0/imisc/Makefile isode-8.0-linux/imisc/Makefile
--- isode-8.0/imisc/Makefile	Tue Jun 16 13:23:44 1992
+++ isode-8.0-linux/imisc/Makefile	Mon Aug 23 13:49:29 1993
@@ -73,6 +73,7 @@
 		-@echo ""
 
 imiscd:		ximiscd$(LPP)
+		:
 
 ximiscd$(LPP):	imiscd.o IMISC-Rops.o ryresponder.o IMISC_tables.o $(LIBES)
 		$(LDCC) $(LDFLAGS) -o $@ imiscd.o IMISC-Rops.o ryresponder.o \
@@ -107,6 +108,7 @@
 		-@echo ""
 
 imisc:		ximisc$(LPP)
+		:
 
 ximisc$(LPP):	imisc.o IMISC-Iops.o ryinitiator.o IMISC_tables.o $(LIBES)
 		$(LDCC) $(LDFLAGS) -o $@ imisc.o IMISC-Iops.o ryinitiator.o \
diff -u --recursive --new-file isode-8.0/imisc/imiscd.c isode-8.0-linux/imisc/imiscd.c
--- isode-8.0/imisc/imiscd.c	Tue Jun 16 13:23:46 1992
+++ isode-8.0-linux/imisc/imiscd.c	Fri Jul  8 17:26:25 1994
@@ -263,7 +263,7 @@
 #define	LMAX	(sizeof (ut -> ut_line))
 #define	NMAX	(sizeof (ut -> ut_name))
 
-#ifdef	SYS5
+#if defined(SYS5) || defined(__linux__)
 struct utmp *getutent ();
 #endif
 
@@ -277,7 +277,7 @@
 caddr_t	in;
 struct RoSAPindication *roi;
 {
-#ifndef	SYS5
+#if !defined(SYS5) && !defined(__linux__)
     int	    ud;
 #endif
     register char  *dp;
@@ -299,7 +299,7 @@
     ia5 = NULL;
     ia5p = &ia5;
 
-#ifndef	SYS5
+#if !defined(SYS5) && !defined(__linux__)
     if ((ud = open ("/etc/utmp", 0)) == NOTOK) {
 	int	result;
 
@@ -344,6 +344,12 @@
 	(void) sprintf (buffer, "%-*.*s %-*.*s %.12s",
 		NMAX, NMAX, ut -> ut_name, LMAX, LMAX, ut -> ut_line,
 		dp + 4);
+
+#ifdef UT_HOSTSIZE
+	if (ut -> ut_host[0])
+	    (void) sprintf (buffer + strlen (buffer), "\t(%.*s)",
+		    UT_HOSTSIZE, ut -> ut_host);
+#endif
 
 	if ((*ia5p = str2ia5list (buffer)) == NULL)
 	    goto congested;
diff -u --recursive --new-file isode-8.0/jump/Makefile isode-8.0-linux/jump/Makefile
--- isode-8.0/jump/Makefile	Thu Jan  1 01:00:00 1970
+++ isode-8.0-linux/jump/Makefile	Thu Jul 14 09:29:36 1994
@@ -0,0 +1,45 @@
+IMAGE=		libisode
+VERSION=	8.0.1
+ADDRESS=	0x63d00000
+JUMPSIZE=	0x8000
+GOTSIZE=	0x2000
+
+
+all:		image stubs
+
+install:
+		ln -f libdsap.sa ../libdsap.a
+		ln -f libftam.sa ../libftam.a
+		ln -f libisode.sa ../libacsap.a
+		ln -f libisode.sa ../libcompat.a
+		ln -f libisode.sa ../libdirent.a
+		ln -f libisode.sa ../libisode.a
+		ln -f libisode.sa ../libpepsy.a
+		ln -f libisode.sa ../libpepy.a
+		ln -f libisode.sa ../libpsap.a
+		ln -f libisode.sa ../libpsap2.a
+		ln -f libisode.sa ../libronot.a
+		ln -f libisode.sa ../librosap.a
+		ln -f libisode.sa ../librosy.a
+		ln -f libisode.sa ../librtsap.a
+		ln -f libisode.sa ../libssap.a
+		ln -f libisode.sa ../libtsap.a
+
+image:
+		/usr/dll/bin/mkimage -l $(IMAGE) -v $(VERSION) \
+			-a $(ADDRESS) -j $(JUMPSIZE) -g $(GOTSIZE) \
+			-- \
+			libftam.a libpepsy.a libpepy.a \
+			libx500as.a libdsap.a libacsap.a libcommon.a libnet.a \
+			librosy.a libronot.a librosap.a \
+			libpsap2.a libpsap.a \
+			librtsap.a libssap.a libtsap.a \
+			libcompat.a libdirent.a \
+			libisode.a \
+			-lcurses -ltermcap -ldbm -lc -lm `gcc --print` -lc
+
+stubs:
+		/usr/dll/bin/mkstubs -l $(IMAGE) -v $(VERSION) \
+			-a $(ADDRESS) -j $(JUMPSIZE) -g $(GOTSIZE) \
+			-- \
+			libisode libdsap libftam
